<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
      onSubmit="return false"
    >
      <!-- <el-form-item label="家族" prop="familyId" v-if="!familyName">
        <el-select v-model="queryParams.familyId" placeholder="请选择家族" clearable size="small">
          <el-option
            v-for="item in familyOptions"
            :key="'f'+item.id"
            :label="item.fullName"
            :value="item.id"
          />
        </el-select>
      </el-form-item> -->
      <el-form-item label="家族名称" prop="familyId">
        <span v-if="family">{{ family.fullName }}</span>
      </el-form-item>
      <el-form-item label="事件标题" prop="title"><el-input v-model="queryParams.title" placeholder="请输入标题" clearable @keyup.enter.native="handleQuery" /></el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:events:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['system:events:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:events:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['system:events:export']"
        >导出</el-button>
      </el-col>
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="eventsList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="id" v-if="false"/>
      <el-table-column label="家族" align="center" prop="familyId" >
        <template slot-scope="scope">
          <span>{{scope.row.family.fullName}}</span>
        </template>
      </el-table-column>
      <el-table-column label="事件标题" align="center" prop="title" />
      <el-table-column label="事件内容" align="center" prop="contents" />
      <el-table-column label="大事件发生日期" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:events:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:events:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改家族大事件对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <!-- <el-form-item label="家族" prop="familyId">
          <el-select v-model="form.familyId" placeholder="请选择家族">
            <el-option
            v-for="item in familyOptions"
            :key="'f'+item.id"
            :label="item.fullName"
            :value="item.id"
          />
          </el-select>
        </el-form-item> -->
       <el-form-item label="家族" prop="familyId">
          <el-tag v-model="form.familyId"><span v-if="family">{{ family.fullName }}</span></el-tag>
        </el-form-item>
        <el-form-item label="事件标题" prop="title">
          <el-input v-model="form.title" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="事件内容" prop="contents">
          <el-input v-model="form.contents" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="大事件发生日期" prop="createTime">
         <el-date-picker v-model="form.createTime" type="date" value-format="yyyy-MM-dd HH:mm:ss" placeholder="选择日期"></el-date-picker>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listEvents, getEvents, delEvents, addEvents, updateEvents, exportEvents } from "@/api/system/events";
import { listFamily, getFamily } from "@/api/system/family";

export default {
  name: "Events",
  data() {
     var validatefamilyId = (rule, value, callback) => {
        if (value == '' || value<=0 || value == null || value == undefined) {
          callback(new Error('家族不能为空'));
        } else{
          callback();
        }
      };
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 家族大事件表格数据
      eventsList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        familyId: null,
        title: null,
      },
      // 表单参数
      form: { id: undefined },
      // 表单校验
      rules: {
        title: [{ required: true, message: "标题不能为空", trigger: "blur" }],
        familyId: [{ validator:validatefamilyId, trigger: "blur" }],
      },
      familyId: undefined,
      family: undefined,
      familyOptions: [],
    };
  },
  activated() {
    this.init()
  },
 mounted () {
    this.init();
    this.getFamilyOptions();
  },
  methods: {
    init(){
    this.familyId = this.$route.query.fid;
      if (this.familyId) {
        this.queryParams.familyId = this.familyId;
        this.getFamilyById(this.familyId);
         this.getList();
      }else{
        this.loading = false;
      }
    },

    /**获取单个家族信息 */
    getFamilyById(_familyId) {
      getFamily(_familyId).then((res) => {
        this.family = res.data;
      });
    },
    
    //获取家族列表
    getFamilyOptions(){
      var _params= {
        pageNum: 1,
        pageSize: 10000000,
        
      }
      listFamily(_params).then(res=>{
       
        if(res.code == 200){
          this.familyOptions = res.rows
        }
      })

    },


    /** 查询家族大事件列表 */
    getList() {
      this.loading = true;
      const fid = this.$route.query.fid;
      this.queryParams.familyId = fid;
      listEvents(this.queryParams).then(response => {
        this.eventsList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        title: null,
        contents: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加家族大事件";
      this.$nextTick(()=>{
        this.form.familyId =this.familyId
      })
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getEvents(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改家族大事件";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateEvents(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              }
            });
          } else {
            addEvents(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除家族大事件编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delEvents(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有家族大事件数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportEvents(queryParams);
        }).then(response => {
          this.download(response.msg);
        }).catch(function() {});
    }
  }
};
</script>
